// Copyright (c) 2015, Xhive LLC
// License: GNU General Public License v3. See license.txt

xhiveframework.query_reports["Employee Leave Balance"] = {
	filters: [
		{
			fieldname: "from_date",
			label: __("From Date"),
			fieldtype: "Date",
			reqd: 1,
			default: xhiveframework.defaults.get_default("year_start_date")
		},
		{
			fieldname: "to_date",
			label: __("To Date"),
			fieldtype: "Date",
			reqd: 1,
			default: xhiveframework.defaults.get_default("year_end_date")
		},
		{
			label: __("Company"),
			fieldname: "company",
			fieldtype: "Link",
			options: "Company",
			reqd: 1,
			default: xhiveframework.defaults.get_user_default("Company")
		},
		{
			fieldname: "department",
			label: __("Department"),
			fieldtype: "Link",
			options: "Department",
		},
		{
			fieldname: "employee",
			label: __("Employee"),
			fieldtype: "Link",
			options: "Employee",
		},
		{
			fieldname: "employee_status",
			label: __("Employee Status"),
			fieldtype: "Select",
			options: [
				"",
				{ "value": "Active", "label": __("Active") },
				{ "value": "Inactive", "label": __("Inactive") },
				{ "value": "Suspended", "label": __("Suspended") },
				{ "value": "Left", "label": __("Left") },
			],
			default: "Active",
		},
		{
			fieldname: "consolidate_leave_types",
			label: __("Consolidate Leave Types"),
			fieldtype: "Check",
			default: 1,
			depends_on: "eval: !doc.employee",
		}
	],

	onload: () => {
		xhiveframework.call({
			type: "GET",
			method: "hrms.hr.utils.get_leave_period",
			args: {
				"from_date": xhiveframework.defaults.get_default("year_start_date"),
				"to_date": xhiveframework.defaults.get_default("year_end_date"),
				"company": xhiveframework.defaults.get_user_default("Company")
			},
			freeze: true,
			callback: (data) => {
				xhiveframework.query_report.set_filter_value("from_date", data.message[0].from_date);
				xhiveframework.query_report.set_filter_value("to_date", data.message[0].to_date);
			}
		});
	}
}
